<template>
  <div style="margin: 3rem">
    <!-- BOTON DE REGRESAR -->
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :isValidate="true" @clickEvent="returnButtonModal = true" :offsetArrow="21" :spanTitle="2" title="Regresar" style="margin-bottom:2.5rem"/>
    </header>

    <!-- MODAL DEL BOTON DE REGRESAR -->
    <AppModalReturn :show-dialog.sync="returnButtonModal" v-if="returnButtonModal" v-on:btnEvent="returnPage" v-on:eventBtn="returnButtonModal = false">
    </AppModalReturn>

    <!-- COMPONENTE TITULO -->
    <h3 class="text-red" style="margin:3rem 6rem">REPOSICIÓN</h3>
    <div style="margin:3rem 6rem">
      <Title :Title="'Capítulo ' +  Chapter.chapter"> </Title>
    </div>
    
    <el-main style="margin:2rem 6rem;">
      <h3 class="text-orange">REPOSICIÓN DEL MATERIAL</h3>
      <el-row style="padding: 10px 10px 20px 20px; margin-bottom: 3rem;">
        <el-col :span="4" class="fonts-bold-general" style="margin-top: 1.5rem">Fecha de Llegada</el-col>
        <el-col :span="4" style="margin-top: 1.5rem">
          <el-date-picker
            v-model="chapterStorageSupport.arrivalDate"
            type="date" :disabled="true"
            size="small"
            format="dd/MM/yyyy"
            value-format="timestamp"
            style="width: 100%">
          </el-date-picker>
        </el-col>
      </el-row>

      <hr class="line-report">
      <h3 class="text-orange" style="margin: 4rem 0px 3rem; ">OBSERVACIONES TÉCNICAS</h3>
      <el-tabs type="card" style="margin: 3rem 0" class="tabContentStyle" v-model="activeName" @tab-click="changeTab(activeName)">
        <el-tab-pane label="Color">
          <div slot="label" class="tab-title">
            <img src="../../../assets/images/icono-color.svg" width="20px" alt="icono-color">
            <img src="../../../assets/images/icono-color-white.svg" width="20px" alt="icono-color">
            <span>COLOR</span>
          </div>
          <div style="margin:2rem 1rem">
            <el-row style="margin: 0 0 1rem">
              <el-col :span="12" :offset="1">
                <el-checkbox-group v-model="Chapter.technicalObservationsOfColor" @change="changeCheckbox(Chapter.technicalObservationsOfColor, 'technicalObservationsOfColor', 'disabledColor', 'needRepColorChapter')">
                  <el-checkbox v-for="(item, index) in arrColor" :key="index" :label="item" style="display:block; margin:0; padding:0.5rem 0"></el-checkbox>
                </el-checkbox-group>
              </el-col>
              <el-col :span="6" :offset="1">
                <div class="box-shadow" style="padding: 1rem">
                  <p class="fonts-bold-general" style="margin-bottom: 1rem">NECESITA REPOSICIÓN</p>
                  <el-radio v-model="Chapter.needRepColorChapter" :disabled="disabledColor" label="SÍ"  style="display:block; margin:0">SÍ</el-radio>
                  <el-radio v-model="Chapter.needRepColorChapter" :disabled="disabledColor" label="NO"  style="display:block; margin:0; padding:0.5rem 0">NO</el-radio>
                </div>
              </el-col>
            </el-row>
            <el-row style="margin: 0 0 3rem">
              <el-col :span="2" :offset="1">Otro:</el-col>
              <el-col :span="6"><el-input v-model="Chapter.anotherColor" size="small"></el-input></el-col>
            </el-row>
          </div>
        </el-tab-pane>
        <el-tab-pane label="Audio">
          <div slot="label" class="tab-title">
            <img src="../../../assets/images/icono-audio.svg" width="22px" alt="icono-audio"> 
            <img src="../../../assets/images/icono-audio-white.svg" width="22px" alt="icono-audio"> 
            <span>AUDIO</span>
          </div>
          <div style="margin:2rem 1rem">
            <el-row style="margin: 0 0 1rem">
              <el-col :span="12" :offset="1">
                <el-checkbox-group v-model="Chapter.audioTechnicalObservations" @change="changeCheckbox(Chapter.audioTechnicalObservations, 'audioTechnicalObservations', 'disabledAudio', 'needRepAudioChapter')">
                  <el-checkbox v-for="item in arrAudio" :key="item" :label="item" style="display:block; margin:0; padding:0.5rem 0"></el-checkbox>
                </el-checkbox-group>
              </el-col>
              <el-col :span="6" :offset="1">
                <div class="box-shadow" style="padding: 1rem">
                  <p class="fonts-bold-general" style="margin-bottom: 1rem">NECESITA REPOSICIÓN</p>
                  <el-radio v-model="Chapter.needRepAudioChapter" :disabled="disabledAudio" label="SÍ" style="display:block; margin:0">SÍ</el-radio>
                  <el-radio v-model="Chapter.needRepAudioChapter" :disabled="disabledAudio" label="NO"  style="display:block; margin:0; padding:0.5rem 0">NO</el-radio>
                </div>
              </el-col>
            </el-row>
            <el-row style="margin: 0 0 3rem">
              <el-col :span="2" :offset="1">Otro:</el-col>
              <el-col :span="6"><el-input v-model="Chapter.anotherAudioChapter" size="small"></el-input></el-col>
            </el-row>
          </div>
        </el-tab-pane>
        <el-tab-pane label="Video">
          <div slot="label" class="tab-title">
            <img src="../../../assets/images/icono-video.svg" width="22px" alt="icono-video"> 
            <img src="../../../assets/images/icono-video-white.svg" width="22px" alt="icono-video"> 
            <span>VIDEO</span>
          </div>
          <div style="margin:2rem 1rem">
            <el-row style="margin: 0 0 1rem">
              <el-col :span="12" :offset="1">
                <el-checkbox-group v-model="Chapter.technicalObservationsVideo" @change="changeCheckbox(Chapter.technicalObservationsVideo, 'technicalObservationsVideo', 'disabledVideo', 'needRepVideoChapter')">
                  <el-checkbox v-for="item in arrVideo" :key="item" :label="item" style="display:block; margin:0; padding:0.5rem 0"></el-checkbox>
                </el-checkbox-group>
              </el-col>
              <el-col :span="6" :offset="1">
                <div class="box-shadow" style="padding: 1rem">
                  <p class="fonts-bold-general" style="margin-bottom: 1rem">NECESITA REPOSICIÓN</p>
                  <el-radio v-model="Chapter.needRepVideoChapter" :disabled="disabledVideo" label="SÍ"  style="display:block; margin:0">SÍ</el-radio>
                  <el-radio v-model="Chapter.needRepVideoChapter" :disabled="disabledVideo" label="NO"  style="display:block; margin:0; padding:0.5rem 0">NO</el-radio>
                </div>
              </el-col>
            </el-row>
            <el-row style="margin: 0 0 3rem">
              <el-col :span="2" :offset="1">Otro:</el-col>
              <el-col :span="6"><el-input v-model="Chapter.anotherVideoChapter" size="small"></el-input></el-col>
            </el-row>
          </div>
        </el-tab-pane>
      </el-tabs>
      <div class="text-end">
        <el-button v-on:click="modalCancelButton = true" class="text-orange border-orange" plain>CANCELAR</el-button>
        <el-button @click="verifyCheckboxAndLabel" type="primary">ACTUALIZAR</el-button>
      </div>

      <!-- Modal botón cancelar -->
      <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="returnPage"  v-on:eventBtn="modalCancelButton = false">
      </AppModalDanger>

      <!-- Modal botón actualizar-->
      <AppModalSuccess :show-dialog.sync="modalActualizar" v-if="modalActualizar" 
        :parrafo="'La revisión de la reposición del <strong> Capítulo ' + Chapter.chapter +  '</strong> se ha guardado. ' "
        btn1="ACEPTAR" v-on:btnEvent="modalActualizar = false" @btnEvent="returnPage">
      </AppModalSuccess>

      <AppModal :show-dialog.sync="modalNeedReposition"  v-if="modalNeedReposition" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
         :parrafo="'Por favor indica si el <strong> Capítulo ' +  Chapter.chapter + '</strong> necesita reposición.'">
      </AppModal>

    </el-main> 
  </div>
</template>

<script>


import ReturnButton from '@/components/ReturnButton.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModal from '@/components/AppModal.vue'

import { HTTP} from '../../../main.js'
import AppModalReturn from '@/components/AppModalReturn.vue'
import Title from '@/components/Title.vue'  

const contObsOptions = ['Lenguaje inapropiado', 'Violencia física y/o psicológica', 'Sangre', 'Alcohol y drogas', 'Desnudos y/o sexo', 'Muerte y crímenes']
const colorOptions = ['OK', 'Setup Alto o Pedestal Alto (Lavado)', 'Desbalanceado (Fades Tend. Al Rojo)', 'Saturación de Croma (Rojos muy vivos)']
const audioOptions = ['OK', 'Sin Audio', 'Volumen Bajo', 'Entrecortado', 'Saturado (Volumen muy alto)', 'CH1', 'CH2']
const videoOptions = ['OK', 'Drops', 'Rayas', 'Pixeleado', 'Nivel Bajo de Video (Oscuro)']

export default {
  components: {
    ReturnButton,
    AppModalDanger,
    AppModalReturn,
    Title,
    AppModalSuccess,
    AppModal,

  },
  data () {
    return {
      arrColor: colorOptions,
      arrAudio: audioOptions,
      arrVideo: videoOptions,
      material: {},
      returnButtonModal: false,
      modalCancelButton: false,
      Chapter: {},
      contractStorageSupport: [],
      admittedMaterialsStorage: [],
      chapterStorageSupport: [],
      materialSelected: [],
      temporada: 0,
      capitulo: 0,
      modalActualizar: false,
      afiliacion: localStorage.getItem('afiliado'),
      disabledColor: true,
      disabledAudio: true,
      disabledVideo: true,
      modalNeedReposition: false,
      activeName: '0',
      prevTab: '0',
    }
  },
  created () {
    this.materialObj()
    this.Chapter = this.$route.params.chapter
    this.temporada = this.$route.params.temporada
    this.capitulo = this.$route.params.capitulo

    // LIMPIA LOS VALORES PARA INGRESAR LA REPOSICION
    this.Chapter.technicalObservationsVideo = []
    this.Chapter.audioTechnicalObservations = []
    this.Chapter.technicalObservationsOfColor = []
    
    this.Chapter.needRepColorChapter = ''
    this.disabledColor = false
    
    this.Chapter.needRepAudioChapter = ''
    this.disabledAudio = false
      
    this.Chapter.needRepVideoChapter = ''
    this.disabledVideo = false
      
    /* --- */
    this.$localStorage.set('localStorageObservations', JSON.stringify(this.Chapter.observations))
    if(this.afiliacion == 'false'){
      this.getStorageSupport(this.material.contractCode, this.material.__id)
    }
  },
  methods: {
    returnButtonPrev() {
      console.log('returnButtonPrev')
      this.$router.push({name: 'formByCap',  params: { chapter: this.Chapter, temporada: (this.temporada + 1), capitulo: (this.capitulo + 1) }})
    },
    getStorageSupport(idContract, idMaterial) {
      HTTP.get(`contracts/contractCode/${idContract}`)
        .then(res => {
          this.contractStorageSupport = res.data.contract[0]
          this.admittedMaterialsStorage = res.data.contract[0].admittedMaterials
          this.admittedMaterialsStorage.map((el, i, arr) => {
            if(el._id  === idMaterial ) {
              this.materialSelected = el
              this.chapterStorageSupport = el.numChapters[this.temporada].infoByChapter[this.capitulo]
            }
          })
        })
        .catch(err => console.log(err));
     },

    returnPage () {
      // this.$router.push({name: 'formByCap',  params: { chapter: this.Chapter, temporada: (this.temporada + 1), capitulo: (this.capitulo + 1) }})
      this.$router.push({name: 'reportCap'})
    },
    materialObj () {
      this.material = JSON.parse(this.$localStorage.get("selectedMaterial"))
    },

    verifyCheckboxAndLabel () {
      var itemSelected = this.Chapter

      if ( this.disabledColor == false && itemSelected.needRepColorChapter == '' || this.disabledAudio == false && itemSelected.needRepAudioChapter == '' || this.disabledVideo == false && itemSelected.needRepVideoChapter == '')  {
        this.modalNeedReposition = true   
      }
      else {
        this.actualizationObservations()
      }
    },

    actualizationObservations(){
      Object.defineProperty(this.Chapter, 'correctionObservations', {
          value: [],
          writable: true,
          enumerable: true,
          configurable: true
        });
        
      if(this.Chapter.needRepColorChapter === 'SÍ') {
        this.Chapter.observations[1].status = 'En espera de Reposición'
      }
      else {
        this.Chapter.observations[1].status = 'No necesita Reposición'      
      }
      if(this.Chapter.needRepAudioChapter === 'SÍ') {
        this.Chapter.observations[2].status = 'En espera de Reposición'
      }
      else {
        this.Chapter.observations[2].status = 'No necesita Reposición'
      } 
      if(this.Chapter.needRepVideoChapter === 'SÍ') {
        this.Chapter.observations[3].status = 'En espera de Reposición'
      }
      else {
        this.Chapter.observations[3].status = 'No necesita Reposición'
      }

      this.Chapter.observations[0].detail = this.Chapter.contentObservations        
      this.Chapter.observations[1].detail = this.Chapter.technicalObservationsOfColor
      this.Chapter.observations[2].detail = this.Chapter.audioTechnicalObservations
      this.Chapter.observations[3].detail = this.Chapter.technicalObservationsVideo
      this.material.numChapters[this.temporada].infoByChapter[this.capitulo] = this.Chapter


      if (this.Chapter.needRepColorChapter === 'SÍ' || this.Chapter.needRepAudioChapter === 'SÍ' || this.Chapter.needRepVideoChapter === 'SÍ'){
        this.Chapter.state = 'pendiente de reposicion' 
        this.Chapter.colorCap = 'text-red'
        if(this.afiliacion == 'true') {
          this.Chapter.radio = "Pendiente"
          this.Chapter.stateStorage = "Pendiente"
          this.Chapter.stateReplacement = 'REPOSICIÓN'
          this.Chapter.replacementReposition = true
          this.Chapter.replacementStorage = true
        } else {
          this.chapterStorageSupport.showreplace = 'REPOSICIÓN'
          this.chapterStorageSupport.statusChapter = 1
          this.chapterStorageSupport.statusStorageChap = 1
          this.chapterStorageSupport.replacement =  true
          this.chapterStorageSupport.replacementStorage =  true
          this.materialSelected.statusMaterial=  2
          this.materialSelected.statusStorage=  2

          HTTP.patch(`contracts/contractCode/${this.material.contractCode}`, [ 
            {propName: "statusContract", value: 'INCOMPLETO'},
            {propName: "statusContractStorage", value: 'INCOMPLETO'},
            {propName: "nameType", value: 'danger'},
            {propName: "nameTypeStorage", value: 'danger'},
            {propName: "admittedMaterials", value: this.admittedMaterialsStorage}
          ])
          .then(res => {})
          .catch(err => console.log(err));
        }
        
        console.log ('Capítulo pendiente de reposición')
      }
      else {
        let observationStorage =  JSON.parse(this.$localStorage.get("localStorageObservations"))

        this.Chapter.colorCap = 'text-green'
        console.log ('Capítulo aprobado')
        if(this.Chapter.observations[1].detail[0] !== observationStorage[1].detail[0]) {
           this.Chapter.observations[1].status = 'CORREGIDO'

          let modify = {
            observations: this.Chapter.observations[1].observations,
            arrivalDate: new Date(this.chapterStorageSupport.arrivalDate).toLocaleDateString('en-GB'),
            detail: observationStorage[1].detail
          }
          this.Chapter.correctionObservations.push(modify)
        }

        if(this.Chapter.observations[2].detail[0] !== observationStorage[2].detail[0]) {
          this.Chapter.observations[2].status = 'CORREGIDO'
          let modify = {
            observations: this.Chapter.observations[2].observations,
            arrivalDate: new Date(this.chapterStorageSupport.arrivalDate).toLocaleDateString('en-GB'),
            detail: observationStorage[2].detail
          }
          this.Chapter.correctionObservations.push(modify)
        }

        if(this.Chapter.observations[3].detail[0] !== observationStorage[3].detail[0]) {
          this.Chapter.observations[3].status = 'CORREGIDO'
          let modify = {
            observations: this.Chapter.observations[3].observations,
            arrivalDate: new Date(this.chapterStorageSupport.arrivalDate).toLocaleDateString('en-GB'),
            detail: observationStorage[3].detail
          }
          this.Chapter.correctionObservations.push(modify)
        }
      }

      if(this.afiliacion == 'true') {
        if(this.Chapter.state == 'pendiente de reposicion' ){
          HTTP.patch(`materials/${this.material.__id}`, [
            {propName: "numChapters", value: this.material.numChapters},
            {propName: "stateBtnSupport", value: 'INCOMPLETO'},
            {propName: "colorBtnSupport", value: 'danger'},
            {propName: "stateBtnStorageSupport", value: 'INCOMPLETO'},
            {propName: "colorBtnStorageSupport", value: 'danger'}
          ])
          .then(res => {
            this.getNewDataOfMaterial()
          })
          .catch(err => console.log(err))
        } else {
          HTTP.patch(`materials/${this.material.__id}`, [
            {propName: "numChapters", value: this.material.numChapters},
          ])
          .then(res => {
            this.getNewDataOfMaterial()
          })
          .catch(err => console.log(err)) 
        }
      } else {
        HTTP.patch(`materials/${this.material.__id}`, [
          {propName: "numChapters", value: this.material.numChapters},
        ])
        .then(res => {
          this.getNewDataOfMaterial()
        })
        .catch(err => console.log(err))
      }
      
    },
    getNewDataOfMaterial(){
      HTTP.get(`materials/${this.material.__id}`)
      .then(resMaterial => {
        let newValueOfMaterial = resMaterial.data.material
        newValueOfMaterial.__id = newValueOfMaterial._id
        this.$localStorage.set('selectedMaterial', JSON.stringify(newValueOfMaterial))
        this.modalActualizar = true
      })
      .catch(err => console.log(err))
    },

    tableRowClassName ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-light-red';
      }
    },
    changeCheckbox (value, item, disabled, label) {
      if (value.length > 0) {
        this[disabled] = false
        if (value.includes('OK')) {
          if(value[0] == 'OK' && value.length > 1){
            this[disabled] = false
            value.shift()
          } else{
            this[disabled] = true
            this.Chapter[item] = ["OK"]
            this.Chapter[label] = ""     
          }
        }
      } else {
        this[disabled] = false
      }
    },

    changeTab (val){
      if(this.prevTab !== val){
        if(this.prevTab == '0'){
          if(this.Chapter.technicalObservationsOfColor.length !== 0){
            if((this.Chapter.technicalObservationsOfColor[0] !== 'OK') && (this.Chapter.needRepColorChapter == '')){
              this.modalNeedReposition = true
            } else{
              this.modalNeedReposition = false
            }
          }
        } else if(this.prevTab == '1'){
          if(this.Chapter.audioTechnicalObservations.length !== 0){
            if((this.Chapter.audioTechnicalObservations[0] !== 'OK') && (this.Chapter.needRepAudioChapter == '')){
              this.modalNeedReposition = true
            } else{
              this.modalNeedReposition = false
            }
          }
        } else if(this.prevTab == '2'){
          if(this.Chapter.technicalObservationsVideo.length !== 0){
            if((this.Chapter.technicalObservationsVideo[0] !== 'OK') && (this.Chapter.needRepVideoChapter == '')){
              this.modalNeedReposition = true
            } else{
              this.modalNeedReposition = false
            }
          }
        }

        this.prevTab = val
      }
    },

  }
}
</script>